import { AuthInterceptor } from './Auth.interceptor';
import { CorsInterceptor } from './Cors.interceptor';
import { RemoveNullParamsInterceptor } from './RemoveNullParams.interceptor';
import { UnderscoreToCamelcaseInterceptor } from './UnderscoreToCamelcase.interceptor';
export * from './Auth.interceptor';
export * from './Cors.interceptor';
export * from './RemoveNullParams.interceptor';
export * from './UnderscoreToCamelcase.interceptor';
/** Http interceptor providers in outside-in order */
export declare const httpInterceptorProviders: ({
    provide: import("@angular/core").InjectionToken<import("@angular/common/http").HttpInterceptor[]>;
    useClass: typeof AuthInterceptor;
    multi: boolean;
} | {
    provide: import("@angular/core").InjectionToken<import("@angular/common/http").HttpInterceptor[]>;
    useClass: typeof CorsInterceptor;
    multi: boolean;
} | {
    provide: import("@angular/core").InjectionToken<import("@angular/common/http").HttpInterceptor[]>;
    useClass: typeof RemoveNullParamsInterceptor;
    multi: boolean;
} | {
    provide: import("@angular/core").InjectionToken<import("@angular/common/http").HttpInterceptor[]>;
    useClass: typeof UnderscoreToCamelcaseInterceptor;
    multi: boolean;
})[];
