import { Observable } from 'rxjs';
export declare class AuthorizationConfig {
    /**
     * @description This will be used for signing your requests. An access token is required for all endpoints
     */
    accessToken: () => Observable<string>;
    /**
     * @description This used to prefix the access- and refreshToken inside the local storage.
     */
    storagePrefix: string;
    /**
     * @description This is an array of all scopes you need your application to access to. Default all scopes will be requested
     */
    scopes?: string[];
}
