import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { CursorPaging } from '../models';
import { Artist } from '../models';
import { ApiConfig } from '../models';
export declare class FollowService {
    private config;
    private http;
    constructor(config: ApiConfig, http: HttpClient);
    isFollowingArtists(ids: string[]): Observable<boolean[]>;
    isFollowingUsers(ids: string[]): Observable<boolean[]>;
    areFollowingPlaylist(playlistId: string, usersToCheck: string[]): Observable<boolean[]>;
    followArtists(ids: string[]): Observable<boolean>;
    followUsers(ids: string[]): Observable<boolean>;
    followPlaylist(id: string, isPublic?: boolean): Observable<boolean>;
    getFollowedArtists(limit?: number, after?: string): Observable<CursorPaging<Artist>>;
    unfollowArtists(ids: string[]): Observable<boolean>;
    unfollowUsers(ids: string[]): Observable<boolean>;
    unfollowPlaylist(id: string): Observable<boolean>;
}
